<!DOCTYPE html>
<html lang="en">
  <head>
    <title>ExchangeController Class Reference</title>
    <link rel="stylesheet" type="text/css" href="../css/jazzy.css" />
    <link rel="stylesheet" type="text/css" href="../css/highlight.css" />
    <meta charset='utf-8'>
    <script src="../js/jquery.min.js" defer></script>
    <script src="../js/jazzy.js" defer></script>
    
  </head>
  <body>
    <a name="//apple_ref/swift/Class/ExchangeController" class="dashAnchor"></a>
    <a title="ExchangeController Class Reference"></a>
    <header>
      <div class="content-wrapper">
        <p><a href="../index.html"> Docs</a> (90% documented)</p>
      </div>
    </header>
    <div class="content-wrapper">
      <p id="breadcrumbs">
        <a href="../index.html"> Reference</a>
        <img id="carat" src="../img/carat.png" />
        ExchangeController Class Reference
      </p>
    </div>
    <div class="content-wrapper">
      <nav class="sidebar">
        <ul class="nav-groups">
          <li class="nav-group-name">
            <a href="../Classes.html">Classes</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="../Classes/AppDelegate.html">AppDelegate</a>
              </li>
              <li class="nav-group-task">
                <a href="../Classes/BackgroundController.html">BackgroundController</a>
              </li>
              <li class="nav-group-task">
                <a href="../Classes/CoreDataManager.html">CoreDataManager</a>
              </li>
              <li class="nav-group-task">
                <a href="../Classes/CurrencyController.html">CurrencyController</a>
              </li>
              <li class="nav-group-task">
                <a href="../Classes/CurrencyRate.html">CurrencyRate</a>
              </li>
              <li class="nav-group-task">
                <a href="../Classes/CurrencyRateManager.html">CurrencyRateManager</a>
              </li>
              <li class="nav-group-task">
                <a href="../Classes/CurrencyRatePack.html">CurrencyRatePack</a>
              </li>
              <li class="nav-group-task">
                <a href="../Classes/CurrencyRatePackParser.html">CurrencyRatePackParser</a>
              </li>
              <li class="nav-group-task">
                <a href="../Classes/ExchangeController.html">ExchangeController</a>
              </li>
              <li class="nav-group-task">
                <a href="../Classes/ExchangeModelManager.html">ExchangeModelManager</a>
              </li>
              <li class="nav-group-task">
                <a href="../Classes/FromCurrencyController.html">FromCurrencyController</a>
              </li>
              <li class="nav-group-task">
                <a href="../Classes/FromCurrencyPageController.html">FromCurrencyPageController</a>
              </li>
              <li class="nav-group-task">
                <a href="../Classes/NetworkManager.html">NetworkManager</a>
              </li>
              <li class="nav-group-task">
                <a href="../Classes/NetworkManager/NetworkManagerError.html">– NetworkManagerError</a>
              </li>
              <li class="nav-group-task">
                <a href="../Classes/ToCurrencyController.html">ToCurrencyController</a>
              </li>
              <li class="nav-group-task">
                <a href="../Classes/ToCurrencyPageController.html">ToCurrencyPageController</a>
              </li>
              <li class="nav-group-task">
                <a href="../Classes/UserData.html">UserData</a>
              </li>
            </ul>
          </li>
          <li class="nav-group-name">
            <a href="../Enums.html">Enums</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="../Enums/CurrencyType.html">CurrencyType</a>
              </li>
              <li class="nav-group-task">
                <a href="../Enums/RequestResult.html">RequestResult</a>
              </li>
            </ul>
          </li>
          <li class="nav-group-name">
            <a href="../Extensions.html">Extensions</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="../Extensions/NSManagedObject.html">NSManagedObject</a>
              </li>
            </ul>
          </li>
          <li class="nav-group-name">
            <a href="../Functions.html">Functions</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="../Functions.html#/s:F15testApplication8debugLogFTSS4fileVs12StaticString8functionS0_4lineSi_T_">debugLog(_:file:function:line:)</a>
              </li>
            </ul>
          </li>
          <li class="nav-group-name">
            <a href="../Protocols.html">Protocols</a>
            <ul class="nav-group-tasks">
              <li class="nav-group-task">
                <a href="../Protocols/CurrencyControllerDelegate.html">CurrencyControllerDelegate</a>
              </li>
            </ul>
          </li>
        </ul>
      </nav>
      <article class="main-content">
        <section>
          <section class="section">
            <h1>ExchangeController</h1>
              <div class="declaration">
                <div class="language">
                  <pre class="highlight"><code><span class="kd">class</span> <span class="kt">ExchangeController</span><span class="p">:</span> <span class="kt">UIViewController</span></code></pre>

                </div>
              </div>
            <p>This is a big fat controller which observe users action with subviewcontrollers, updates them if needed and controls exhange-operations.</p>

          </section>
          <section class="section task-group-section">
            <div class="task-group">
              <ul>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:vC15testApplication18ExchangeController18invisibleTextFieldGSQCSo11UITextField_"></a>
                    <a name="//apple_ref/swift/Property/invisibleTextField" class="dashAnchor"></a>
                    <a class="token" href="#/s:vC15testApplication18ExchangeController18invisibleTextFieldGSQCSo11UITextField_">invisibleTextField</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>invisible textfield is used for UIPageViewControllers switch operations. When user starts to change page, invisibleTextField become a first responder(if it&rsquo;s needed). So the KeyBoard doesn&rsquo;t dissapear.</p>

                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight"><code><span class="kd">@IBOutlet</span> <span class="kd">private(set)</span> <span class="k">var</span> <span class="nv">invisibleTextField</span><span class="p">:</span> <span class="kt">UITextField</span><span class="o">!</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:vC15testApplication18ExchangeController30fromCurrencyPageViewControllerGSQCS_26FromCurrencyPageController_"></a>
                    <a name="//apple_ref/swift/Property/fromCurrencyPageViewController" class="dashAnchor"></a>
                    <a class="token" href="#/s:vC15testApplication18ExchangeController30fromCurrencyPageViewControllerGSQCS_26FromCurrencyPageController_">fromCurrencyPageViewController</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>This UIPageViewController controls <q>sell</q> part of view.</p>

                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight"><code><span class="kd">private(set)</span> <span class="k">var</span> <span class="nv">fromCurrencyPageViewController</span><span class="p">:</span> <span class="kt"><a href="../Classes/FromCurrencyPageController.html">FromCurrencyPageController</a></span><span class="o">!</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:vC15testApplication18ExchangeController28toCurrencyPageViewControllerGSQCS_24ToCurrencyPageController_"></a>
                    <a name="//apple_ref/swift/Property/toCurrencyPageViewController" class="dashAnchor"></a>
                    <a class="token" href="#/s:vC15testApplication18ExchangeController28toCurrencyPageViewControllerGSQCS_24ToCurrencyPageController_">toCurrencyPageViewController</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>This UIPageViewController controls <q>buy</q> part of view.</p>

                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight"><code><span class="kd">private(set)</span> <span class="k">var</span> <span class="nv">toCurrencyPageViewController</span><span class="p">:</span> <span class="kt"><a href="../Classes/ToCurrencyPageController.html">ToCurrencyPageController</a></span><span class="o">!</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:vC15testApplication18ExchangeController23exchangeModelControllerCS_20ExchangeModelManager"></a>
                    <a name="//apple_ref/swift/Property/exchangeModelController" class="dashAnchor"></a>
                    <a class="token" href="#/s:vC15testApplication18ExchangeController23exchangeModelControllerCS_20ExchangeModelManager">exchangeModelController</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>Model controller</p>

                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight"><code><span class="kd">private(set)</span> <span class="k">var</span> <span class="nv">exchangeModelController</span> <span class="o">=</span> <span class="kt"><a href="../Classes/ExchangeModelManager.html">ExchangeModelManager</a></span><span class="p">(</span><span class="nv">pageCurrencyTypes</span><span class="p">:</span> <span class="n">currencyTypes</span><span class="p">,</span> <span class="nv">context</span><span class="p">:</span> <span class="kt"><a href="../Classes/CoreDataManager.html">CoreDataManager</a></span><span class="o">.</span><span class="n">sharedInstance</span><span class="o">.</span><span class="n"><a href="../Classes/ExchangeController.html#/s:vC15testApplication18ExchangeController20managedObjectContextCSo22NSManagedObjectContext">managedObjectContext</a></span><span class="p">)</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:vC15testApplication18ExchangeController20managedObjectContextCSo22NSManagedObjectContext"></a>
                    <a name="//apple_ref/swift/Property/managedObjectContext" class="dashAnchor"></a>
                    <a class="token" href="#/s:vC15testApplication18ExchangeController20managedObjectContextCSo22NSManagedObjectContext">managedObjectContext</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>Observed managed object context.</p>

                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight"><code><span class="k">let</span> <span class="nv">managedObjectContext</span> <span class="o">=</span> <span class="kt"><a href="../Classes/CoreDataManager.html">CoreDataManager</a></span><span class="o">.</span><span class="n">sharedInstance</span><span class="o">.</span><span class="n">managedObjectContext</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:vC15testApplication18ExchangeController11userDataFRCGCSo26NSFetchedResultsControllerCS_8UserData_"></a>
                    <a name="//apple_ref/swift/Property/userDataFRC" class="dashAnchor"></a>
                    <a class="token" href="#/s:vC15testApplication18ExchangeController11userDataFRCGCSo26NSFetchedResultsControllerCS_8UserData_">userDataFRC</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>This fecthed results controller observes changes of <strong>UserData</strong> in managed object context</p>

                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight"><code><span class="k">var</span> <span class="nv">userDataFRC</span><span class="p">:</span> <span class="kt">NSFetchedResultsController</span><span class="o">&lt;</span><span class="kt"><a href="../Classes/UserData.html">UserData</a></span><span class="o">&gt;</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:vC15testApplication18ExchangeController16currencyRatesFRCGCSo26NSFetchedResultsControllerCS_16CurrencyRatePack_"></a>
                    <a name="//apple_ref/swift/Property/currencyRatesFRC" class="dashAnchor"></a>
                    <a class="token" href="#/s:vC15testApplication18ExchangeController16currencyRatesFRCGCSo26NSFetchedResultsControllerCS_16CurrencyRatePack_">currencyRatesFRC</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>This fecthed results controller observes changes of <strong>CurrencyRatePack</strong> objects in managed object context.</p>

                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight"><code><span class="k">var</span> <span class="nv">currencyRatesFRC</span><span class="p">:</span> <span class="kt">NSFetchedResultsController</span><span class="o">&lt;</span><span class="kt"><a href="../Classes/CurrencyRatePack.html">CurrencyRatePack</a></span><span class="o">&gt;</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:FC15testApplication18ExchangeController11viewDidLoadFT_T_"></a>
                    <a name="//apple_ref/swift/Method/viewDidLoad()" class="dashAnchor"></a>
                    <a class="token" href="#/s:FC15testApplication18ExchangeController11viewDidLoadFT_T_">viewDidLoad()</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>Undocumented</p>

                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight"><code><span class="kd">class</span> <span class="kt">ExchangeController</span><span class="p">:</span> <span class="kt">UIViewController</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:FC15testApplication18ExchangeController14viewWillAppearFSbT_"></a>
                    <a name="//apple_ref/swift/Method/viewWillAppear(_:)" class="dashAnchor"></a>
                    <a class="token" href="#/s:FC15testApplication18ExchangeController14viewWillAppearFSbT_">viewWillAppear(_:)</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>Undocumented</p>

                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight"><code><span class="kd">class</span> <span class="kt">ExchangeController</span><span class="p">:</span> <span class="kt">UIViewController</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:FC15testApplication18ExchangeController16keyboardWillShowFCSo14NSNotificationT_"></a>
                    <a name="//apple_ref/swift/Method/keyboardWillShow(_:)" class="dashAnchor"></a>
                    <a class="token" href="#/s:FC15testApplication18ExchangeController16keyboardWillShowFCSo14NSNotificationT_">keyboardWillShow(_:)</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>This method is called by notification when keyboard appears. It is used to control bottom offset of view.</p>

                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight"><code><span class="kd">func</span> <span class="nf">keyboardWillShow</span><span class="p">(</span><span class="n">_</span> <span class="nv">notification</span><span class="p">:</span> <span class="kt">NSNotification</span><span class="p">)</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:FC15testApplication18ExchangeController7prepareFT3forCSo17UIStoryboardSegue6senderGSqP___T_"></a>
                    <a name="//apple_ref/swift/Method/prepare(for:sender:)" class="dashAnchor"></a>
                    <a class="token" href="#/s:FC15testApplication18ExchangeController7prepareFT3forCSo17UIStoryboardSegue6senderGSqP___T_">prepare(for:sender:)</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>Undocumented</p>

                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight"><code><span class="kd">class</span> <span class="kt">ExchangeController</span><span class="p">:</span> <span class="kt">UIViewController</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:FC15testApplication18ExchangeController20exchangeButtonTappedFT_T_"></a>
                    <a name="//apple_ref/swift/Method/exchangeButtonTapped()" class="dashAnchor"></a>
                    <a class="token" href="#/s:FC15testApplication18ExchangeController20exchangeButtonTappedFT_T_">exchangeButtonTapped()</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>This method is called by button <q>Exchange</q> on tap.</p>

                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight"><code><span class="kd">func</span> <span class="nf">exchangeButtonTapped</span><span class="p">()</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:FC15testApplication18ExchangeController20reloadExchangeButtonFT_T_"></a>
                    <a name="//apple_ref/swift/Method/reloadExchangeButton()" class="dashAnchor"></a>
                    <a class="token" href="#/s:FC15testApplication18ExchangeController20reloadExchangeButtonFT_T_">reloadExchangeButton()</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>Reloads <strong>exchangeButton</strong>. It&rsquo;s enabled when user has enouth money for exchange operation &amp; when source &amp; destionation currencies are not equal.</p>

                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight"><code><span class="kd">func</span> <span class="nf">reloadExchangeButton</span><span class="p">()</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
              </ul>
            </div>
            <div class="task-group">
              <ul>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:FC15testApplication18ExchangeController18currencyControllerFTCS_18CurrencyController15valueWasChangedGSqCSo15NSDecimalNumber__T_"></a>
                    <a name="//apple_ref/swift/Method/currencyController(_:valueWasChanged:)" class="dashAnchor"></a>
                    <a class="token" href="#/s:FC15testApplication18ExchangeController18currencyControllerFTCS_18CurrencyController15valueWasChangedGSqCSo15NSDecimalNumber__T_">currencyController(_:valueWasChanged:)</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>UICurrencyViewControllerDelegate.currencyViewController(:valueWasChanged:) handler.</p>

                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight"><code><span class="kd">func</span> <span class="nf">currencyController</span><span class="p">(</span><span class="n">_</span> <span class="nv">currencyController</span><span class="p">:</span> <span class="kt"><a href="../Classes/CurrencyController.html">CurrencyController</a></span><span class="p">,</span> <span class="n">valueWasChanged</span> <span class="nv">value</span><span class="p">:</span> <span class="kt">NSDecimalNumber</span><span class="p">?)</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
              </ul>
            </div>
            <div class="task-group">
              <ul>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:FC15testApplication18ExchangeController18pageViewControllerFTCSo20UIPageViewController16willTransitionToGSaCSo16UIViewController__T_"></a>
                    <a name="//apple_ref/swift/Method/pageViewController(_:willTransitionTo:)" class="dashAnchor"></a>
                    <a class="token" href="#/s:FC15testApplication18ExchangeController18pageViewControllerFTCSo20UIPageViewController16willTransitionToGSaCSo16UIViewController__T_">pageViewController(_:willTransitionTo:)</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>UIPageViewControllerDelegate.pageViewController(:willTransitionToViewControllers:) handler.</p>

                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight"><code><span class="kd">func</span> <span class="nf">pageViewController</span><span class="p">(</span><span class="n">_</span> <span class="nv">pageViewController</span><span class="p">:</span> <span class="kt">UIPageViewController</span><span class="p">,</span> <span class="n">willTransitionTo</span> <span class="nv">pendingViewControllers</span><span class="p">:</span> <span class="p">[</span><span class="kt">UIViewController</span><span class="p">])</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:FC15testApplication18ExchangeController18pageViewControllerFTCSo20UIPageViewController18didFinishAnimatingSb23previousViewControllersGSaCSo16UIViewController_19transitionCompletedSb_T_"></a>
                    <a name="//apple_ref/swift/Method/pageViewController(_:didFinishAnimating:previousViewControllers:transitionCompleted:)" class="dashAnchor"></a>
                    <a class="token" href="#/s:FC15testApplication18ExchangeController18pageViewControllerFTCSo20UIPageViewController18didFinishAnimatingSb23previousViewControllersGSaCSo16UIViewController_19transitionCompletedSb_T_">pageViewController(_:didFinishAnimating:previousViewControllers:transitionCompleted:)</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>UIPageViewControllerDelegate.pageViewController(:didFinishAnimating:didFinishAnimating:transitionCompleted:) handler.</p>

                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight"><code><span class="kd">func</span> <span class="nf">pageViewController</span><span class="p">(</span><span class="n">_</span> <span class="nv">pageViewController</span><span class="p">:</span> <span class="kt">UIPageViewController</span><span class="p">,</span> <span class="n">didFinishAnimating</span> <span class="nv">finished</span><span class="p">:</span> <span class="kt">Bool</span><span class="p">,</span> <span class="nv">previousViewControllers</span><span class="p">:</span> <span class="p">[</span><span class="kt">UIViewController</span><span class="p">],</span> <span class="n">transitionCompleted</span> <span class="nv">completed</span><span class="p">:</span> <span class="kt">Bool</span><span class="p">)</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
              </ul>
            </div>
            <div class="task-group">
              <ul>
                <li class="item">
                  <div>
                    <code>
                    <a name="/s:FC15testApplication18ExchangeController26controllerDidChangeContentFGCSo26NSFetchedResultsControllerPSo20NSFetchRequestResult__T_"></a>
                    <a name="//apple_ref/swift/Method/controllerDidChangeContent(_:)" class="dashAnchor"></a>
                    <a class="token" href="#/s:FC15testApplication18ExchangeController26controllerDidChangeContentFGCSo26NSFetchedResultsControllerPSo20NSFetchRequestResult__T_">controllerDidChangeContent(_:)</a>
                    </code>
                  </div>
                  <div class="height-container">
                    <div class="pointer-container"></div>
                    <section class="section">
                      <div class="pointer"></div>
                      <div class="abstract">
                        <p>NSFetchedResultsControllerDelegate.controllerDidChangeContent(:) handler.</p>

                      </div>
                      <div class="declaration">
                        <h4>Declaration</h4>
                        <div class="language">
                          <p class="aside-title">Swift</p>
                          <pre class="highlight"><code><span class="kd">func</span> <span class="nf">controllerDidChangeContent</span><span class="p">(</span><span class="n">_</span> <span class="nv">controller</span><span class="p">:</span> <span class="kt">NSFetchedResultsController</span><span class="o">&lt;</span><span class="kt">NSFetchRequestResult</span><span class="o">&gt;</span><span class="p">)</span></code></pre>

                        </div>
                      </div>
                    </section>
                  </div>
                </li>
              </ul>
            </div>
          </section>
        </section>
        <section id="footer">
          <p>&copy; 2017 <a class="link" href="" target="_blank" rel="external"></a>. All rights reserved. (Last updated: 2017-01-05)</p>
          <p>Generated by <a class="link" href="https://github.com/realm/jazzy" target="_blank" rel="external">jazzy ♪♫ v0.7.3</a>, a <a class="link" href="http://realm.io" target="_blank" rel="external">Realm</a> project.</p>
        </section>
      </article>
    </div>
  </body>
</div>
</html>
